;GSL demo written by Robert Niedziela
;This demo explains how to use double buffering and UserCounter variable.
;
;Press "EXIT" key to exit demo.

#include "asm86.h"
#include "ti86asm.inc"


.org _asm_exec_ram
        call    _runindicoff
        call    OpenGray

        ld      hl, GrayPic_bit1        ;copy picture to bit planes
        ld      de, (Pages)
        ld      bc, 1024
        ldir
        ld      hl, GrayPic_bit2
        ld      de, (Pages+2)
        ld      bc, 1024
        ldir
        ld      hl, GrayPic_bit1
        ld      de, (Pages+4)
        ld      bc, 1024
        ldir
        ld      hl, GrayPic_bit2
        ld      de, (Pages+6)
        ld      bc, 1024
        ldir

        ld      hl, (Pages)                     ;draw "Demo" on first bit plane
        call    PutDemoBmp                      ;on page 1

Repeat:
        call    getkey
        jr      z, RepeatEnd
        ld      a, (UserCounter)                ;check UserCounter value
        cp      100
        jr      nz, Repeat
        call    FlipPages
        xor     a
        ld      (UserCounter), a                ;clear UserCounter
        jr      Repeat

RepeatEnd:
        call    CloseGray
        call    _runindicon
        ret


PutDemoBmp:
        ld      bc, 549
        add     hl, bc
        ld      d, h
        ld      e, l
        ld      hl, DemoBmp
        ld      a, 13
PutDemoBmpLoop:
        ld      bc, 6
        ldir
        push    hl
        ld      h, d
        ld      l, e
        ld      bc, 10
        add     hl, bc
        ld      d, h
        ld      e, l
        pop     hl
        dec     a
        cp      0
        jr      nz, PutDemoBmpLoop
        ret



getkey:
        ld a,%00111111
        out (1),a
        nop
        nop
        in a,(1)
        bit 6,a
        ret


#include "gsl4b86.asm"
#include "gsl_bmp.asm"
#include "demo_bmp.asm"
.END
